import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { ChevronDown, ChevronRight } from "lucide-react";
import { useState } from "react";
import { useCustomRouter } from "..";
const DefaultSidebarLiItem = ({ activeUrl, url, anchorText, children, ...props }) => {
    const router = useCustomRouter();
    const handleNavigation = (urlParam, e) => {
        e.preventDefault();
        router.push(urlParam);
    };
    return (_jsxs("li", { className: `rbt-sidebar-li ${activeUrl === url ? "rbt-sidebar-li-active" : ""}`, ...props, children: [_jsx("a", { href: url, className: "rbt-sidebar-a", onClick: (e) => handleNavigation(url, e), children: anchorText }), children] }));
};
const DefaultSidebarSubmenu = ({ subMenuUrls, activeUrl, isOpen }) => {
    if (!isOpen) {
        return null;
    }
    return (_jsx("ul", { className: "rbt-submenu-ul", children: Object.entries(subMenuUrls).map(([url, title], index) => (_jsx(DefaultSidebarLiItem, { activeUrl: activeUrl, url: url, anchorText: title }, index))) }));
};
// The initial open state of a submenu is open === true if:
// 1. The activeUrl is the same as the url of the submenu.
// 2. The activeUrl is belongs to the submenu.
const initialIsSubmenuOpen = (activeUrl, url, currentSubmenu) => {
    if (activeUrl === url) {
        return true;
    }
    if (currentSubmenu && Object.keys(currentSubmenu).includes(activeUrl)) {
        return true;
    }
    return false;
};
const TitleAndSubmenu = ({ titleAndSubmenu, url, menuEntries, activeUrl }) => {
    const title = titleAndSubmenu[0];
    const submenu = titleAndSubmenu[1];
    const [submenuOpen, setSubmenuOpen] = useState(initialIsSubmenuOpen(activeUrl, url, submenu));
    if (submenu) {
        const onChevronClick = (e) => {
            e.stopPropagation();
            setSubmenuOpen(!submenuOpen);
        };
        return (_jsxs(_Fragment, { children: [_jsx(DefaultSidebarLiItem, { activeUrl: activeUrl, anchorText: title, url: url, children: submenuOpen ? (_jsx(ChevronDown, { size: 20, onClick: onChevronClick, className: "rbt-chevron" }))
                        : (_jsx(ChevronRight, { size: 20, className: "rbt-chevron", onClick: onChevronClick })) }), _jsx("li", { children: _jsx(DefaultSidebarSubmenu, { isOpen: submenuOpen, subMenuUrls: submenu, activeUrl: activeUrl }) })] }));
    }
    return (_jsx(DefaultSidebarLiItem, { activeUrl: activeUrl, url: url, anchorText: title }));
};
export const DefaultSidebar = ({ sidebarMenu, activeUrl, isOpen = true, ...props }) => {
    const menuEntries = Object.entries(sidebarMenu || {});
    const classNames = "rbt-sidebar " + (isOpen ? "rbt-force-display" : "");
    if (menuEntries.length === 0) {
        return _jsx("p", { children: "sidebarMenu has no entries :(" });
    }
    return (_jsx("div", { className: classNames, ...props, children: _jsx("ul", { className: "rbt-sidebar-ul", children: menuEntries.map(([url, titleAndSubmenu], index) => (_jsx(TitleAndSubmenu, { menuEntries: menuEntries, titleAndSubmenu: titleAndSubmenu, url: url, activeUrl: activeUrl }, index))) }) }));
};
