import { jsx as _jsx } from "react/jsx-runtime";
import { useCSS } from '..';
import { defaultContainerId } from '../constants';
import { testContainerStyles } from '../styles';
import { TestProvider } from './TestContext';
export const toUrlParam = (title) => {
    return title.toLowerCase().replace(/[^a-z0-9]+/g, '-').replace(/(^-|-$)/g, '');
};
export const TestContainer = ({ id = defaultContainerId, beforeEach, afterEach, beforeAll, afterAll, css = testContainerStyles, children, ...props }) => {
    const cssAdded = useCSS("rbt-test-container-styles", css);
    return (_jsx(TestProvider, { containerId: id, beforeAndAfterFunctions: { beforeEach, afterEach, beforeAll, afterAll }, children: _jsx("div", { id: id, "data-test-container": id, style: cssAdded ? {} : {
                display: "none",
            }, ...props, children: children }) }));
};
